#pragma once

#include <cpu/cpu.h>
#include <cartridge/cartridge.h>
#include <cartridge/mbc/mbc1.h>
#include <memory/ram.h>
#include <memory/bus.h>
#include <memory/register.h>

class DMG
{
private:
  RAM wram1;
  RAM wram2;
  RAM hram;
  RAM oam;

  MBC1 mbc;

  Bus bus;
  Cpu cpu;

  BoundRegister ie_mapped;
  BoundRegister if_mapped;

public:
  System(Cartridge cart);

  void run();
};
